Subject: Re: branch description as a note?

From: "Bence Ferdinandy" <[email-masked]>
Date: Wed, 11 Dec 2024 23:11:30 +0100

On Wed Dec 11, 2024 at 18:37, Konstantin Ryabitsev <[email-masked]> wrote:
> On Thu, Dec 12, 2024 at 01:11:06AM +0900, Junio C Hamano wrote:
>> > Now my problem with the description being a local configuration, is that
>> > I often work on patches on two different computers. I can easily share my patch
>> > notes with myself, but not the branch description. If these could be pushed and
>> > fetched like a note, I think that would open up some other nice possibilities
>> > as well, like having a standard place for MR/PR messages for forges, sharing
>> > proposed merge commit messages, maybe other things.
>> 
>> If this is about draft work, I would use an empty commit at the tip
>> of the branch.
>
> I think this was discussed a while back:
> https://lore.kernel.org/git/[email-masked]/
>
> I think it boiled down to having a merge commit at the tip that would indicate
> the base-commit of the WIP range. I still think it's an awesome idea if
> something like this was natively supported by git tools.
>
> -K

I read through the thread and it seems to me that in essence a special empty
commit was suggested to be used to a similar effect. I think instead of using
a "magic" commit directly in the DAG, it would be much cleaner to store this
separately in a special "branch note". "format-patch" and "am" could be taught
to handle it automatically. I do really like the idea of having a special
syntax in the note to that would delineate the branch description proper (which
could go into a merge commit) from respin versioning of a series.

It could also serve as a nice and built-in way of sharing information about
more permanent branches, e.g. the git project could publish via this special
branch note some of the info about next and seen, that is now somewhere in the
documentation. Forges could easily display it and it might also make it easier
to discover how a repository is structured after cloning.